CiviCRM Drupal 8 Module
=======================

This is the integration module required to allow CiviCRM and 
Drupal 8 to work together.

For Views integration, please use: [civicrm_entity](https://github.com/eileenmcnaughton/civicrm_entity/tree/8.x-3.x). As per [dev/drupal#39](https://lab.civicrm.org/dev/drupal/issues/39), the views integration from this module has been removed.

Documentation
----------------------------

To install CiviCRM on Drupal 8 see the [Drupal 8 section of the CiviCRM Installation Guide](https://docs.civicrm.org/installation/en/latest/drupal8/)

Contribute
----------

If you want to contribute to the development of this module, please bear the following in mind:

* We currently do not have any automated testing setup on Drupal8, so please do a fair amount of testing.
* Many of the pull-request reviewers are not yet fully up to date on Drupal8. Please provide enough information so that we can understand the proposed change and the potential impacts.
* Please open issues on CiviCRM's Gitlab: https://lab.civicrm.org/dev/drupal/issues/

If you have any questions, please join the [Drupal channel on CiviCRM's chat](https://chat.civicrm.org/civicrm/channels/drupal)

We are very grateful for the contributions so far, a lot of amazing work has been done already. The CiviCRM Drupal8 integration is almost ready and there are many organisations already using it in production. However, we also need to invest into improving some of the CiviCRM core bits that will make it easier to use Composer, improve our continuous integration and test coverage for Drupal, and fix a few remaining difficult issues that for now require various workarounds.

Welcome to CiviCRM and thank you for contributing!

About CiviCRM
-------------

CiviCRM is web-based, open source, Constituent Relationship Management (CRM) software geared toward meeting the needs of non-profit and other civic-sector organizations.

As a non profit committed to the public good itself, CiviCRM understands that forging and growing strong relationships with constituents is about more than collecting and tracking constituent data - it is about sustaining relationships with supporters over time.

To this end, CiviCRM has created a robust web-based, open source, highly customizable, CRM to meet organizations’ highest expectations right out-of-the box. Each new release of this open source software reflects the very real needs of its users as enhancements are continually given back to the community.

With CiviCRM's robust feature set, organizations can further their mission through contact management, fundraising, event management, member management, mass e-mail marketing, peer-to-peer campaigns, case management, and much more.

CiviCRM is localized in over 20 languages including: Chinese (Taiwan, China), Dutch, English (Australia, Canada, U.S., UK), French (France, Canada), German, Italian, Japanese, Russian, and Swedish.

For more information, visit the CiviCRM website.
